Index: replay/Replay.prj
===================================================================
--- replay/Replay.prj	(revision 17)
+++ replay/Replay.prj	(revision 18)
@@ -35,7 +35,6 @@
 antic_dma_clock.vhdl
 antic.vhdl
 complete_address_decoder.vhdl
-countdown_timer.vhdl
 cpu_65xx_e.vhd
 cpu_65xx_a.vhd
 cpu_6510.vhd
@@ -50,13 +49,14 @@
 internalromram.vhd
 irq_glue.vhdl
 pia.vhdl
+pokey_countdown_timer.vhdl
 pokey_keyboard_scanner.vhdl
 pokey_mixer.vhdl
 pokey_noise_filter.vhdl
 pokey.vhdl
-poly_17_9.vhdl
-poly_4.vhdl
-poly_5.vhdl
+pokey_poly_17_9.vhdl
+pokey_poly_4.vhdl
+pokey_poly_5.vhdl
 reg_file.vhdl
 shared_enable.vhdl
 simple_counter.vhdl
@@ -63,14 +63,10 @@
 synchronizer.vhdl
 syncreset_enable_divider.vhd
 wide_delay_line.vhdl
-zpupkg.vhd
-zpu_config_regs.vhdl
-zpu_core.vhd
-zpu_glue.vhdl
-zpu_rom.vhdl
 basic.vhdl
 os16.vhdl
 covox.vhd
 atari800core.vhd
+atari800core_simple_sdram.vhd
 Core_Top.vhd
 Replay_Top.vhd
Index: replay/build.sh
===================================================================
--- replay/build.sh	(revision 17)
+++ replay/build.sh	(revision 18)
@@ -6,8 +6,9 @@
 
 embed_roms=0
 
+REPLAY_BASE=/home/markw/fpga/svn/replay/src/hw/replay/cores/replay_lib/
 
-. /home/markw/altera/xilinx/ise/14.7/ISE_DS/settings32.sh
+. /home/markw/fpga/xilinx/14.7/ISE_DS/settings64.sh
 
 if [ $embed_roms = 1 ]; then
     pushd sdcard
@@ -24,8 +25,14 @@
 mkdir -p build
 pushd build
 
-cp -p ../../replay_lib/rtl/*.vhd .
-cp -p ../source/*.v* .
+# copy source files
+cp -p ${REPLAY_BASE}/rtl/*.vhd .
+cp -p ../source/*.vhd .
+cp -p ../source/*.vhdl .
+cp -p ../../common/a8core/*.vhd .
+cp -p ../../common/a8core/*.vhdl .
+cp -p ../../common/components/*.vhd .
+cp -p ../../common/components/*.vhdl .
 
 cp -p ../$name.ucf .
 cp -p ../$name.ut .
Index: replay/simulate.sh
===================================================================
--- replay/simulate.sh	(revision 17)
+++ replay/simulate.sh	(revision 18)
@@ -7,9 +7,10 @@
 
 name=Replay
 
+REPLAY_BASE=/home/markw/fpga/svn/replay/src/hw/replay/cores/replay_lib/
 
 
-. /home/markw/altera/xilinx/ise/14.7/ISE_DS/settings32.sh
+. /home/markw/fpga/xilinx/14.7/ISE_DS/settings64.sh
 
 mkdir -p sim
 pushd sim
@@ -26,14 +27,18 @@
 
         # copy testbench files
         cp -p ../tb/Replay_tb.vhd .
-        cp -p ../../replay_lib/tb/ddr.v .
-        cp -p ../../replay_lib/tb/ddr_parameters.vh .
-        cp -p ../../replay_lib/tb/Replay_I2C_CH7301.vhd .
+        cp -p ${REPLAY_BASE}/tb/ddr.v .
+        cp -p ${REPLAY_BASE}/tb/ddr_parameters.vh .
+        cp -p ${REPLAY_BASE}/tb/Replay_I2C_CH7301.vhd .
 
         # copy source files
-        cp -p ../../replay_lib/rtl/*.vhd .
+        cp -p ${REPLAY_BASE}/rtl/*.vhd .
         cp -p ../source/*.vhd .
         cp -p ../source/*.vhdl .
+	cp -p ../../common/a8core/*.vhd .
+	cp -p ../../common/a8core/*.vhdl .
+	cp -p ../../common/components/*.vhd .
+	cp -p ../../common/components/*.vhdl .
 
 
         # set up project definition file
Index: replay/source/Core_Top.vhd
===================================================================
--- replay/source/Core_Top.vhd	(revision 17)
+++ replay/source/Core_Top.vhd	(revision 18)
@@ -53,6 +53,7 @@
   use ieee.std_logic_1164.all;
   use ieee.std_logic_unsigned.all;
   use ieee.numeric_std.all;
+  use IEEE.STD_LOGIC_MISC.all;
 
   use work.Replay_Pack.all;
   use work.Replay_VideoTiming_Pack.all;
@@ -215,17 +216,80 @@
   signal core_blank_count_next : std_logic_vector(23 downto 0);
   signal core_blank_count_reg : std_logic_vector(23 downto 0);
 
+  SIGNAL	THROTTLE_COUNT_6502 :  STD_LOGIC_VECTOR(5 DOWNTO 0);
+
+  SIGNAL	CONSOL_OPTION :  STD_LOGIC;
+  SIGNAL	CONSOL_SELECT :  STD_LOGIC;
+  SIGNAL	CONSOL_START :  STD_LOGIC;
+
+  SIGNAL	KEYBOARD_RESPONSE :  STD_LOGIC_VECTOR(1 DOWNTO 0);
+  SIGNAL	KEYBOARD_SCAN :  STD_LOGIC_VECTOR(5 DOWNTO 0);
+
+  signal keyboard_scan_inv : std_logic_vector(5 downto 0);
+  signal matrix_out_match : std_logic_vector(7 downto 0);
+
 begin
   -- core control
   res_s <= i_Rst_Core;
   core_en_s <= i_Ena_Sys and not i_Halt_Core and not pause_key;
 
-PLL_LOCKED <= not(i_rst_sys or i_Rst_Core);
-atari800core : entity work.atari800core
-	PORT map
+  -- atari keyboard
+	keyboard_scan_inv <= not(keyboard_scan);
+
+a4051: entity work.complete_address_decoder
+	generic map (width => 3)
+	PORT map ( addr_in => keyboard_scan_inv(5 downto 3), addr_decoded => matrix_in ); 
+
+b4051: entity work.complete_address_decoder
+	generic map (width => 3)
+	PORT map ( addr_in => keyboard_scan_inv(2 downto 0), addr_decoded => matrix_out_match ); 
+
+	process(matrix_out, matrix_out_match)
+	begin
+		keyboard_response(0) <= '1';
+
+		if (or_reduce(matrix_out(7 downto 0) and matrix_out_match(7 downto 0)) = '1') then
+			keyboard_response(0) <= '0';
+		end if;
+	end process;
+
+	process(static_keys, pause_key)
+	begin
+		keyboard_response(1) <= '1';
+
+		if (keyboard_scan(5 downto 4)="00" and pause_key = '1') then
+			keyboard_response(1) <= '0';
+		end if;
+		
+		if (keyboard_scan(5 downto 4)="10" and static_keys(0) = '1') then
+			keyboard_response(1) <= '0';
+		end if;
+
+		if (keyboard_scan(5 downto 4)="11" and static_keys(1) = '1') then
+			keyboard_response(1) <= '0';
+		end if;
+	end process;
+
+	CONSOL_START <= static_keys(6);
+	CONSOL_SELECT <= static_keys(5);
+	CONSOL_OPTION <= static_keys(4);
+--	system_reset_request <= static_keys(3);
+
+	PLL_LOCKED <= not(i_rst_sys or i_Rst_Core);
+	
+	THROTTLE_COUNT_6502 <= std_logic_vector(to_unsigned(16-1,6));
+
+atarixl_simple_sdram1 : entity work.atari800core_simple_sdram
+	GENERIC MAP
 	(
+		cycle_length => 16,
+		internal_rom => 0,
+		internal_ram => 0
+	)
+	PORT MAP
+	(
 		CLK => i_clk_sys,
-		PLL_LOCKED => PLL_LOCKED,
+		RESET_N => PLL_LOCKED,
 
 		VGA_VS => core_vsync,
 		VGA_HS => core_hsync,
@@ -233,17 +297,23 @@
 		VGA_G => core_g_s,
 		VGA_R => core_r_s,
 
-		matrix_out => matrix_out,
-		matrix_in => matrix_in,
-		static_keys => static_keys,
-		pause_key => pause_key,
-
-		JOY1_n => i_Joy_A,
-		JOY2_n => i_Joy_B,
-		
 		AUDIO_L => lsound_s,
 		AUDIO_R => rsound_s,
 
+		JOY1_n => i_Joy_B(4 downto 0),
+		JOY2_n => i_Joy_A(4 downto 0),
+
+		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
+		KEYBOARD_SCAN => KEYBOARD_SCAN,
+
+		SIO_COMMAND => o_RS232_RTS,
+		SIO_RXD => i_RS232_RXD,
+		SIO_TXD => o_RS232_TXD,
+
+		CONSOL_OPTION => CONSOL_OPTION,
+		CONSOL_SELECT => CONSOL_SELECT,
+		CONSOL_START => CONSOL_START,
+
 		SDRAM_REQUEST => SDRAM_REQUEST,
 		SDRAM_REQUEST_COMPLETE => SDRAM_REQUEST_COMPLETE,
 		SDRAM_READ_ENABLE => SDRAM_READ_ENABLE,
@@ -251,20 +321,72 @@
 		SDRAM_ADDR => SDRAM_ADDR,
 		SDRAM_DO => SDRAM_DO,
 		SDRAM_DI => SDRAM_DI,
-		SDRAM_WIDTH_8bit_ACCESS => SDRAM_WIDTH_8bit_ACCESS,
-		SDRAM_WIDTH_16bit_ACCESS => SDRAM_WIDTH_16bit_ACCESS,
-		SDRAM_WIDTH_32bit_ACCESS => SDRAM_WIDTH_32bit_ACCESS,
+		SDRAM_32BIT_WRITE_ENABLE => SDRAM_WIDTH_32bit_ACCESS,
+		SDRAM_16BIT_WRITE_ENABLE => SDRAM_WIDTH_16bit_ACCESS,
+		SDRAM_8BIT_WRITE_ENABLE => SDRAM_WIDTH_8bit_ACCESS,
 
-		SIO_RXD => i_RS232_RXD,
-		SIO_TXD => o_RS232_TXD,
-		SIO_COMMAND_TX => o_RS232_RTS,
+		-- TODO, these sdram signals should come from PBI, not from DMA...
+		-- TODO, review what I can share form PBI/DMA...
+		DMA_FETCH => '0',
+		DMA_READ_ENABLE => '0',
+		DMA_32BIT_WRITE_ENABLE => '0',
+		DMA_16BIT_WRITE_ENABLE => '0',
+		DMA_8BIT_WRITE_ENABLE => '0',
+		DMA_ADDR => (others=>'1'),
+		DMA_WRITE_DATA => (others=>'0'),
+		MEMORY_READY_DMA => open,
 
-		ram_select => ram_select,
-		rom_select => rom_select,
-
-		halt => i_Halt_Core
+   		RAM_SELECT => ram_select,
+    		ROM_SELECT => rom_select,
+		PAL => '1',
+		HALT => i_Halt_Core,
+		THROTTLE_COUNT_6502 => THROTTLE_COUNT_6502
 	);
 
+--atari800core : entity work.atari800core
+--	PORT map
+--	(
+--		CLK => i_clk_sys,
+--		PLL_LOCKED => PLL_LOCKED,
+--
+--		VGA_VS => core_vsync,
+--		VGA_HS => core_hsync,
+--		VGA_B => core_b_s,
+--		VGA_G => core_g_s,
+--		VGA_R => core_r_s,
+--
+--		matrix_out => matrix_out,
+--		matrix_in => matrix_in,
+--		static_keys => static_keys,
+--		pause_key => pause_key,
+--
+--		JOY1_n => i_Joy_A,
+--		JOY2_n => i_Joy_B,
+--		
+--		AUDIO_L => lsound_s,
+--		AUDIO_R => rsound_s,
+--
+--		SDRAM_REQUEST => SDRAM_REQUEST,
+--		SDRAM_REQUEST_COMPLETE => SDRAM_REQUEST_COMPLETE,
+--		SDRAM_READ_ENABLE => SDRAM_READ_ENABLE,
+--		SDRAM_WRITE_ENABLE => SDRAM_WRITE_ENABLE,
+--		SDRAM_ADDR => SDRAM_ADDR,
+--		SDRAM_DO => SDRAM_DO,
+--		SDRAM_DI => SDRAM_DI,
+--		SDRAM_WIDTH_8bit_ACCESS => SDRAM_WIDTH_8bit_ACCESS,
+--		SDRAM_WIDTH_16bit_ACCESS => SDRAM_WIDTH_16bit_ACCESS,
+--		SDRAM_WIDTH_32bit_ACCESS => SDRAM_WIDTH_32bit_ACCESS,
+--
+--		SIO_RXD => i_RS232_RXD,
+--		SIO_TXD => o_RS232_TXD,
+--		SIO_COMMAND_TX => o_RS232_RTS,
+--
+--		ram_select => ram_select,
+--		rom_select => rom_select,
+--
+--		halt => i_Halt_Core
+--	);
+
   ----------------------------------------------------------
   -- KEYBOARD MAPPER
   ----------------------------------------------------------
